﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGComplexBindingCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = vm;            
        }

        private void FGLP_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
        }

        private void xdg1_Loaded(object sender, RoutedEventArgs e)
        {
            FieldLayout layout = xdg1.DefaultFieldLayout;

            int size = vm.Data[0].ChildCollection.Count();

            for (int i = 0; i < size; i++)
            {
                Field field = new Field() { Name = "Child Data " + i.ToString() };


                //Both of these work!!
                string bindingPath = "ChildCollection[" + i.ToString() + "].RandomNumber";
                string bindingPathUsingStringFormat = string.Format("ChildCollection[{0}].RandomNumber", i.ToString());

                Binding b = new Binding(bindingPathUsingStringFormat);
                field.AlternateBinding = b;
                layout.Fields.Add(field);
            }


            layout.Fields["Name"].CellValuePresenterStyle = GetCVPStyle();            

        }

        private Style GetCVPStyle()
        {
            Style style = new Style(typeof(CellValuePresenter));

            ContextMenu menu = new ContextMenu();
            menu.Items.Add(new MenuItem() { Header = "This will only show on Name Field" });

            style.Setters.Add(new Setter(CellValuePresenter.ContextMenuProperty, menu));

            return style;

        }

    }
}
